<xs:schema attributeFormDefault="unqualified" elementFormDefault="qualified"
           xmlns:xs="http://www.w3.org/2001/XMLSchema">

  <xs:complexType name="script_call" mixed="true">
    <xs:attribute name="src" type="xs:string"/>
    <xs:attribute name="start" type="xs:string" use="optional"/>
    <xs:attribute name="env" type="xs:string" use="optional"/>
  </xs:complexType>


  <xs:complexType name="str" mixed="true">
    <xs:attribute name="id" type="xs:string"/>
  </xs:complexType>
  
  <xs:complexType name="value">
    <xs:attribute name="of" type="xs:string"/>
  </xs:complexType>
  
  <xs:complexType name="set" mixed="true">
    <xs:attribute name="var" type="xs:string"/>
  </xs:complexType>

  <xs:complexType name="msg" mixed="true">
    <xs:sequence>
      <xs:element name="value" type="value" minOccurs="0" maxOccurs="unbounded"/>
    </xs:sequence>

    <xs:attribute name="id" type="xs:string" use="optional"/>
    <xs:attribute name="str" type="xs:string" use="optional"/>
    <xs:attribute name="to" type="xs:string" use="optional"/>
    <xs:attribute name="media" type="xs:string" use="optional"/>
  </xs:complexType>

  <xs:complexType name="block">
    <xs:choice minOccurs="0" maxOccurs="unbounded">
      <xs:element name="str" type="str"/>
      <xs:element name="set" type="set"/>
      <xs:element name="msg" type="msg"/>
      <xs:element name="ask" type="ask"/>
      <xs:element name="btn" type="btn"/>
      <xs:element name="block" type="block"/>
      <xs:element name="enable" type="enable"/>
      <xs:element name="script" type="script_call"/>
      <xs:element name="timer" type="timer"/>
    </xs:choice>
    <xs:attribute name="id" type="xs:string"/>
    <xs:attribute name="for" type="xs:string"/>
    <xs:attribute name="arg" type="xs:string"/>
  </xs:complexType>

  <xs:complexType name="enable">
    <xs:complexContent>
      <xs:extension base="block">
        <xs:attribute name="when" type="xs:string"/>
      </xs:extension>
    </xs:complexContent>
  </xs:complexType>

  <xs:complexType name="btn">
    <xs:complexContent>
      <xs:extension base="block">
        <xs:attribute name="str" type="xs:string" use="optional"/>
      </xs:extension>
    </xs:complexContent>
  </xs:complexType>

  <xs:complexType name="ask">
    <xs:complexContent>
      <xs:extension base="msg">
        <xs:attribute name="var" type="xs:string"/>
        <xs:attribute name='validator' type="xs:string"/>
      </xs:extension>
    </xs:complexContent>
  </xs:complexType>
  
  <xs:complexType name="scenario">
    <xs:complexContent>
      <xs:extension base="block">
        
      </xs:extension>
    </xs:complexContent>
  </xs:complexType>

  <xs:complexType name="timer">
    <xs:complexContent>
      <xs:extension base="block">
        <xs:attribute name="delay" type="xs:string"/>
      </xs:extension>
    </xs:complexContent>
  </xs:complexType>


  <xs:element name="script" type="scenario"/>

</xs:schema>